<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <link rel="stylesheet" href="css/style.css">
    <link href='https://fonts.googleapis.com/css?family=Open Sans' rel='stylesheet'>
    <title>task 30.20</title>
</head>

<body>
    <div class="container">
        <form action="" id="singUp-form">
            <div class="singUp-form">
                <div class="title">Create a free account</div>
                <div class="form">
                    <div class="row">
                        <div class="col-md-5 form-right">
                            <div class="title-your-name">Name</div>
                            <div class="input-name"><input type="text" id="input-name" placeholder="Your name"></div>
                            <div class="title-email">E-mail</div>
                            <div class="input-email"><input type="text" id="input-email"
                                    placeholder="Your e-mail address"></div>
                            <div class="title-password">Password</div>
                            <div class="input-password"><input type="password" id="input-password"></div>
                            <div class="title-confirm-password">Cofirm Password</div>
                            <div class="input-confirm-password"><input type="password" id="input-confirm-password">
                            </div>
                            <button type="submit" class="sign-up">Sign up</button>
                            <div class="text-under">
                                <div class="text-under1">By signing up you agree to our </div>
                                <div class="text-under2"> Terms of Servicey </div>
                                <div class="text-under3"> and </div>
                                <div class="text-under4"> Privacy Policy</div>
                            </div>
                            <div class="footer-form">
                                <div class="footer-text">Already have an account?</div>
                                <a href="#">Login</a>
                            </div>
                        </div>
                        <div class="col-md-5">
                            <div class="image">
                                <img src="imagem.png" alt="anh">
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </form>
    </div>
</body>

<script>
    'use strict';
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gREQUEST_STATUS_OK = 200;
    const gBASE_URL = "https://62458c222cfed18817229118.mockapi.io/users";

    var gSingUpFormElement = document.getElementById("singUp-form");

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    gSingUpFormElement.addEventListener("submit", function (paramEvent) {
        // Loại bỏ mặc định của submit form
        paramEvent.preventDefault();

        callAPISingUp();
    });

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function callAPISingUp() {
        // Thu thập dữ liệu
        var vNameValue = document.getElementById("input-name").value;
        var vEmailValue = document.getElementById("input-email").value;
        var vPasswordValue = document.getElementById("input-password").value;
        var vConfirmPasswordValue = document.getElementById("input-confirm-password").value;

        // Kiểm tra dữ liệu
        var vValidate = validateForm(vEmailValue, vPasswordValue, vConfirmPasswordValue);

        if (vValidate) {
            // Chuẩn bị input
            var vQueryParams = new URLSearchParams({
                email: vEmailValue,
                password: vPasswordValue,
                confirmPassword: vConfirmPasswordValue
            })

            // Create a request 
            var vXMLHttpLoginRequest = new XMLHttpRequest();
            vXMLHttpLoginRequest.open("GET", gBASE_URL + "?" + vQueryParams.toString(), true);
            vXMLHttpLoginRequest.send();
            vXMLHttpLoginRequest.onreadystatechange =
                function () {
                    if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                        var vSingUpInfoResponse = vXMLHttpLoginRequest.responseText;

                        var vSingUpInfo = JSON.parse(vSingUpInfoResponse);

                        if (vSingUpInfo.length > 0) {
                            alert("Đăng ký thành công.");
                        } else {
                            alert("Đăng ký thất bại.");
                        }
                    }
                }
        }
    }

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    function validateForm(paramEmail, paramPassword, paramConfirmPassword) {
        if (!paramEmail.includes("@")) {
            alert("Email không đúng định dạng");
            return false;
        }

        if (paramPassword.length < 8) {
            alert("Độ dài mật khẩu phải lớn hơn hoặc bằng 8");
            return false;
        }
        if (paramConfirmPassword != paramPassword) {
            alert("Mật khẩu phải giống nhau")
            return false;
        }

        return true;
    }
</script>

</html>